/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package projekat9;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTable;
import javax.swing.JTextField;



/**
 *
 * @author sjokic
 */
public class Fakultet {
    
    public List<Student> listaStudenata;
    
    String nazivFakulteta;
    
    //konstruktor
    public Fakultet(String nazivFakulteta){
        
        listaStudenata = new ArrayList<>();
        this.nazivFakulteta = nazivFakulteta;
    }
    
    //set metod
    public void setFakultet(List<Student> listaStudenata){
        
        this.listaStudenata = listaStudenata;
    }
    //get metod
    public List<Student> getFakultet(){
        
        return this.listaStudenata;
    }
    
    //dodavanje studenta u listu
    public void dodajStudenta(Student s){
        
        this.listaStudenata.add(s);
    }
    
    //pomocni metod za pravljenje novog studenta
    private Student noviStudent(String ime, String prezime, String brojIndeksa, String datumUpisa){
        
        Student s = new Student(ime,prezime,brojIndeksa,datumUpisa);
        
        return s;
    }
    
    
    //metod za prikaz podataka
    
    private Object[][] prikaziPodatke(){
        
        Object[][] podaci = new Object[this.listaStudenata.size()][4];
        
        Iterator<Student> it = listaStudenata.iterator();
        int brojac = 0;
        
        
        while(it.hasNext()){
            
            Student s = it.next();
            Object[] podaciStudenta = new Object[4];
            podaciStudenta[0] = s.getIme();
            podaciStudenta[1] = s.getPrezime();
            podaciStudenta[2] = s.getBrojIndeksa();
            podaciStudenta[3] = s.getDatumUpisa();
            
            
            podaci[brojac] = podaciStudenta;
            brojac++;
        }
        
        return podaci;
    }
    
    
    //metod za prikazivanje podataka u tabeli
    
    private void prikaziUTabeli(JTable jtb){
        
        Object[] nazivKolona = {"Ime","Prezime","Broj indeksa","Datum upisa"};
        
        jtb.setModel(new javax.swing.table.DefaultTableModel(prikaziPodatke(), nazivKolona));
    }
    
    
    //metod za ciscenje inputa
    
    private void ocistiPolja(JTextField ime, JTextField prezime, JTextField brojIndeksa, JTextField datumUpisa){
        
        ime.setText(null);
        prezime.setText(null);
        brojIndeksa.setText(null);
        datumUpisa.setText(null);
    }
    
    
    
    //serijalizacija
    
    private void serijalizuj(List<Student> listaStudenata){
        
        try {
            FileOutputStream fos = new FileOutputStream("Podaci.txt");
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            
            oos.writeObject(listaStudenata);
            oos.close();
            fos.close();
            
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Fakultet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Fakultet.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    
    public void unesiPodatke(JTextField ime,JTextField prezime,JTextField brojIndeksa, JTextField datumUpisa, JTable tabela){
        
        
        dodajStudenta(noviStudent(ime.getText().toUpperCase(), prezime.getText().toUpperCase(), brojIndeksa.getText(),datumUpisa.getText()));
        
        ocistiPolja(ime,prezime,brojIndeksa,datumUpisa);
        
        prikaziUTabeli(tabela);
        serijalizuj(listaStudenata);
    
    }
    
    
    //deserijalizacija
    
    private void deserijalizuj(){
        
        try {
            FileInputStream fis = new FileInputStream("Podaci.txt");
            ObjectInputStream ois = new ObjectInputStream(fis);
            
            this.listaStudenata = (List<Student>)ois.readObject();
            ois.close();
            fis.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Fakultet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Fakultet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Fakultet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
    public void ucitajUTabelu(JTable jtb){
        
        try{
        deserijalizuj();
        prikaziUTabeli(jtb);
        }catch(Exception e){
            
        }
        
    }
    
    
}
